
LOCAL_PATH:= $(call my-dir)

#--------------------------------------------------------
# libmirror.so
#--------------------------------------------------------
include $(CLEAR_VARS)


LOCAL_MODULE			:= mirror
LOCAL_CPPFLAGS 			+= -std=c++17
LOCAL_SRC_FILES			:= ../../../Src/Android/Main.cpp \
						   ../../../Src/Android/AudioEngine.cpp \
						   ../../../Src/Application.cpp \
						   ../../../Src/LipSync.cpp \
						   ../../../Src/AvatarBody.cpp \
						   ../../../Src/AvatarControllers.cpp \
						   ../../../Src/AvatarHands.cpp \
						   ../../../Src/Mesh.cpp \
						   ../../../Src/VertexBufferWriter.cpp \
						   ../../../Src/Shaders.cpp \
						   ../../../Src/TextureLoader.cpp \
						   ../../../Src/Utilities/GlCore.cpp \
						   ../../../Src/Utilities/GlBuffer.cpp \
						   ../../../Src/Utilities/GlTexture.cpp \
						   ../../../Src/Utilities/GlProgram.cpp \
						   ../../../Src/Utilities/MemoryMap_Android.cpp \
						   ../../../Src/Utilities/Log.cpp   
						   
LOCAL_C_INCLUDES :=  $(LOCAL_PATH)/../../../Dependencies/glm-0.9.9.5

LOCAL_LDLIBS			:= -llog -landroid -lGLESv3 -lEGL -lOpenSLES		# include default libraries

# Explicitly compile for the ARM and not the Thumb instruction set.
LOCAL_ARM_MODE 			:= arm
LOCAL_ARM_NEON  		:= true

LOCAL_LDFLAGS			:= -u ANativeActivity_onCreate

LOCAL_STATIC_LIBRARIES	:= android_native_app_glue OVRLipSyncShim
LOCAL_SHARED_LIBRARIES	:= vrapi libovrplatformloader libovravatarloader OVRLipSync

include $(BUILD_SHARED_LIBRARY)

ifneq ("$(wildcard $(LOCAL_PATH)/../../../../../Android/jni)","")
	AVATAR_SDK_PATH := ../../../../Android/jni
else
	AVATAR_SDK_PATH := ../../../../Loader/jni
endif

$(call import-module,android/native_app_glue)
$(call import-module,VrApi/Projects/AndroidPrebuilt/jni)
$(call import-module,../OVRPlatformSDK_v1.36.0/Android/jni)
$(call import-module,$(AVATAR_SDK_PATH))
$(call import-module,../OVRLipSyncNative_1.37.0/AndroidPrebuilt/jni)
