#pragma once
#include <functional>

static const uint32_t SampleRate = 48000;
static const uint32_t SamplesPerTick = 960;
static const uint32_t PlayBufferSize = SamplesPerTick * 2; // stereo
static const uint32_t MicBufferSize = SamplesPerTick;

using PlayCallback_t = std::function<void(short* buffer)>;
using MicCallback_t = std::function<void(short* buffer)>;

// Mic is only implemented on android currently, either or both can be nullptr if your not
// interested.
// Because of the use of platform microphone, this must be called after platform has been
// initialized.
void AudioEngineInitialize(PlayCallback_t playCallback, MicCallback_t micCallback);
void AudioEngineShutdown();
