#pragma once
#include <atomic>
#include <vector>
#include "OVRLipSync.h"
#include "Utilities/Locked.h"

class ovrLipSync {
 public:
  ovrLipSync();
  ~ovrLipSync();
  ovrLipSync(const ovrLipSync&) = delete;
  ovrLipSync(ovrLipSync&&) = delete;
  ovrLipSync& operator=(const ovrLipSync&) = delete;
  ovrLipSync& operator=(ovrLipSync&&) = delete;

  void ProcessAudio(const int16_t* buffer, uint32_t numSamples);
  uint32_t GetVisemeCount() const;
  std::vector<float> GetVisemes() const;

 private:
  void OnFinishedProcessingAudio(const ovrLipSyncFrame* pFrame, ovrLipSyncResult result);

  ovrLipSyncContext Context{0};
  ovrUtilities::Locked<std::vector<float>> CurrentVisemes;
  std::atomic_bool CurrentlyProcessing{false};
  std::atomic_bool Initialized{false};
};
