#pragma once
#include "OVR_Avatar.h"

#include "glm/gtc/quaternion.hpp"
#include "glm/gtc/type_ptr.hpp"
#include "glm/gtx/transform.hpp"
#include "glm/mat4x4.hpp"

inline glm::mat4 Convert(const ovrAvatarTransform& transform) {
  glm::quat rot = glm::make_quat((float*)&transform.orientation);
  glm::vec3 tran = glm::make_vec3((float*)&transform.position);
  glm::vec3 scale = glm::make_vec3((float*)&transform.scale);
  return glm::translate(tran) * glm::mat4_cast(rot) * glm::scale(scale);
}
