#pragma once
#ifdef ANDROID
#include <alloca.h>
#endif
#include <malloc.h>
#include <cstddef>
#include <cstdio>
#include <string>
#include <type_traits>

namespace ovrUtilities {
template <typename... ArgT>
std::string Format(const char* fmt, const ArgT&... args);
}

// implmentation
template <typename... ArgT>
std::string ovrUtilities::Format(const char* fmt, const ArgT&... args) {
  size_t size = snprintf(nullptr, 0, fmt, args...) + 1;
#ifdef ANDROID
  char* buf = (char*)alloca(size);
#else // windows
  char* buf = (char*)_alloca(size);
#endif
  snprintf(buf, size, fmt, args...);
  return std::string{buf};
}
