#pragma once

#ifdef ANDROID
#include <EGL/egl.h>
#include <EGL/eglext.h>
#include <GLES2/gl2.h>
#include <GLES2/gl2ext.h>
#include <GLES3/gl3.h>
#include <GLES3/gl31.h>
#include <GLES3/gl3ext.h>
#else // Windows
#define NOMINMAX // stop Windows.h from redefining min and max and breaking std::min / std::max
#include <GL/glew.h>
#include <GL/wglew.h>
#endif

#include <cstdint>

namespace ovrUtilities {
// Built into opengl es 3.2. So dont need this once we are on Android N as a minimum.
bool HasTextureBufferExtension();

// 1 if current device doesn't support anisotropic filtering, otherwise usually 16
int32_t GetMaxAnisotropic();

void SetDebugCallback(
    void (*callback)(
        GLenum source,
        GLenum type,
        GLuint id,
        GLenum severity,
        GLsizei length,
        const GLchar* message,
        const void* usrPtr),
    const void* usrPtr);

// follow opengl naming conventions for extensions;
void glTexBufferEXT(GLenum target, GLenum internalformat, GLuint buffer);
} // namespace ovrUtilities
