#pragma once
#include <stdarg.h> /* va_list, va_start, va_arg, va_end */
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void LogWithTag(const int prio, const char* tag, const char* fmt, ...);

#ifdef ANDROID
#include <android/log.h>

#define OVR_LOG(...) LogWithTag(ANDROID_LOG_INFO, __FILE__, __VA_ARGS__)
#define OVR_WARN(...) LogWithTag(ANDROID_LOG_WARN, __FILE__, __VA_ARGS__)
#define OVR_FAIL(...)                                     \
  {                                                       \
    LogWithTag(ANDROID_LOG_ERROR, __FILE__, __VA_ARGS__); \
    abort();                                              \
  }

#else // windows

#define OVR_LOG(...) LogWithTag(0, __FILE__, __VA_ARGS__)
#define OVR_WARN(...) LogWithTag(0, __FILE__, __VA_ARGS__)
#define OVR_FAIL(...)                     \
  {                                       \
    LogWithTag(0, __FILE__, __VA_ARGS__); \
    exit(0);                              \
  }

#endif
