#pragma once

#ifdef ANDROID
#include <jni.h>
void SetAssetManager(JNIEnv* env, jobject assetManager);
#endif

#include <cstdint>
#include <memory>

namespace ovrUtilities {
class MemoryMap {
 public:
  MemoryMap() = default;
  virtual ~MemoryMap() = default;
  MemoryMap(const MemoryMap&) = delete;
  MemoryMap(MemoryMap&& other) = delete;
  MemoryMap& operator=(const MemoryMap&) = delete;
  MemoryMap& operator=(MemoryMap&& other) = delete;

  virtual const void* data() const = 0;
  virtual uint32_t size() const = 0;
};

std::unique_ptr<MemoryMap> CreateMemoryMap(const char* fileName);
} // namespace ovrUtilities
